import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

// TODO
// Evtl. ist Namen selber setzten noch unmöglich
//

public class startMultiplayerGame extends JPanel {
    // Funktionshilfen
    int semesterCounter = 1; // Semester Counter Label
    String PlayerNickname = "Spieler 1";
    // Grafiken
    ImageIcon backButtonIcon = new ImageIcon("graphics/backButton.png");
    ImageIcon humanPlayerIcon = new ImageIcon("graphics/humanPlayer.png");
    ImageIcon aiPlayerEasyIcon = new ImageIcon("graphics/botPlayerEasy.png");
    ImageIcon aiPlayerNormalIcon = new ImageIcon("graphics/botPlayerNormal.png");
    ImageIcon aiPlayerHardIcon = new ImageIcon("graphics/botPlayerHard.png");

    // Labels
    JLabel frameTitle = new JLabel("Multiplayer Spiel");
    JLabel semesterLabel = new JLabel("Semester");
    JLabel PlayerName = new JLabel("Name");
    JLabel PlayerIcon = new JLabel(humanPlayerIcon);
    JLabel semesterCounterLabel = new JLabel(String.valueOf(semesterCounter));

    // Buttons
    JButton backButton = new JButton(backButtonIcon);
    JButton PlayerLeftButton = new JButton("<-");
    JButton PlayerRightButton = new JButton("->");
    JButton semesterUpButton = new JButton("^");
    JButton semesterDownButton = new JButton("v");
    JButton createGameButton = new JButton("Spiel erstellen");
    JButton joinGameButton = new JButton("Spiel beitreten");

    // Textfelder
    JTextField PlayerTextField = new JTextField(20);

    // Konstruktor
    startMultiplayerGame(MainFrame frame) {
        setLayout(null);  // Setze das Layout für das Panel auf null

        // Setze Komponentenpositionen und füge sie dem Panel hinzu
        frameTitle.setBounds(20, 20, 200, 30);
        add(frameTitle);

        semesterLabel.setBounds(700, 300, 200, 30);
        add(semesterLabel);

        PlayerName.setBounds(50, 625, 200, 30);
        add(PlayerName);

        PlayerIcon.setBounds(75, 400, 200, 128);
        add(PlayerIcon);

        semesterCounterLabel.setBounds(725, 475, 50, 50); // zwischen den Up/Down-Buttons
        semesterCounterLabel.setHorizontalAlignment(SwingConstants.CENTER);
        add(semesterCounterLabel);

        // Füge Buttons hinzu und setze ihre Positionen
        backButton.setBounds(1380, 20, 80, 80);
        add(backButton);

        PlayerLeftButton.setBounds(50, 450, 50, 50);
        add(PlayerLeftButton);

        PlayerRightButton.setBounds(250, 450, 50, 50);
        add(PlayerRightButton);

        semesterUpButton.setBounds(725, 400, 50, 50);
        add(semesterUpButton);

        semesterDownButton.setBounds(725, 550, 50, 50);
        add(semesterDownButton);

        joinGameButton.setBounds(1100, 350, 200, 50);
        add(joinGameButton);

        createGameButton.setBounds(1100, 550, 200, 50);
        add(createGameButton);

        // Füge das Textfeld hinzu
        PlayerTextField.setBounds(50, 650, 250, 50);
        PlayerTextField.setText(PlayerNickname);
        add(PlayerTextField);

        /* TODO: Muss in Lucas klasse rein.
        public static void startOnlineGame(Class<? extends LocalPlayer> localPlayerClass, String localPlayerName, InetSocketAddress
        address, int size) throws IOException {
        */

        //GameController.startOnlineGame(...);



            // ActionListener für Buttons
        // SEMESTERBUTTONS
        semesterUpButton.addActionListener(e -> {
            if (semesterCounter < 6) {
                semesterCounter++;
                semesterCounterLabel.setText(String.valueOf(semesterCounter));
            }
        });

        semesterDownButton.addActionListener(e -> {
            if (semesterCounter > 1) {
                semesterCounter--;
                semesterCounterLabel.setText(String.valueOf(semesterCounter));
            }
        });

        // PLAYERTOGGLEBUTTONS
        PlayerLeftButton.addActionListener(e -> {
            togglePlayerIconLeft();
            updateTextFields();
        });

        PlayerRightButton.addActionListener(e -> {
            togglePlayerIconRight();
            updateTextFields();
        });

        // ActionListener für den "Back" Button, um zum vorherigen Panel zurückzukehren

        backButton.addActionListener(e -> frame.showPanel("MainMenu"));
        //joinGameButton.addActionListener(e -> frame.showPanelSMG("JoinGame",1));
        //createGameButton.addActionListener(e -> frame.showPanelSMG("JoinGame",0));

        joinGameButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                //Parameter -> panelName, Spiel erstellen oder beitreten (int), Spielertyp(int 0-3), Spielername
                if (PlayerIcon.getIcon() == humanPlayerIcon) { // TODO Wird name wirklich weitergegeben?
                    frame.showPanelSMG("JoinGame",1,0, PlayerNickname);
                } else if ( PlayerIcon.getIcon() == aiPlayerEasyIcon) {
                    frame.showPanelSMG("JoinGame",1,1, PlayerNickname);
                } else if ( PlayerIcon.getIcon() == aiPlayerNormalIcon) {
                    frame.showPanelSMG("JoinGame",1,2, PlayerNickname);
                } else if ( PlayerIcon.getIcon() == aiPlayerHardIcon) {
                    frame.showPanelSMG("JoinGame",1,3, PlayerNickname);
                }
            }
        });

        createGameButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                //Parameter -> panelName, Spiel erstellen oder beitreten (int), Spielertyp(int 0-3), Spielername
                if (PlayerIcon.getIcon() == humanPlayerIcon) { // TODO Wird name wirklich weitergegeben?
                    frame.showPanelSMG("JoinGame",0,0, PlayerNickname);
                } else if ( PlayerIcon.getIcon() == aiPlayerEasyIcon) {
                    frame.showPanelSMG("JoinGame",0,1, PlayerNickname);
                } else if ( PlayerIcon.getIcon() == aiPlayerNormalIcon) {
                    frame.showPanelSMG("JoinGame",0,2, PlayerNickname);
                } else if ( PlayerIcon.getIcon() == aiPlayerHardIcon) {
                    frame.showPanelSMG("JoinGame",0,3, PlayerNickname);
                }
            }
        });
        /*
        startButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                frame.showPanelSLGLS("startLocalGameLoadingScreen", semesterCounter); //TODO
                if (leftPlayerIcon.getIcon() == humanPlayerIcon) {// TODO Wird name wirklich weitergegeben?
                    if (rightPlayerIcon.getIcon() == aiPlayerEasyIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerEasy.class, GameController.semesterToBoardSize(semesterCounter));
                    } else if (rightPlayerIcon.getIcon() == aiPlayerNormalIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerMedium.class, GameController.semesterToBoardSize(semesterCounter));
                    } else if (rightPlayerIcon.getIcon() == aiPlayerHardIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerHard.class, GameController.semesterToBoardSize(semesterCounter));
                    }
                } else if (leftPlayerIcon.getIcon() == aiPlayerEasyIcon) {
                    if (rightPlayerIcon.getIcon() == aiPlayerEasyIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerEasy.class, GameController.semesterToBoardSize(semesterCounter));
                    } else if (rightPlayerIcon.getIcon() == aiPlayerNormalIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerMedium.class, GameController.semesterToBoardSize(semesterCounter));
                    } else if (rightPlayerIcon.getIcon() == aiPlayerHardIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerHard.class, GameController.semesterToBoardSize(semesterCounter));
                    }
                } else if (rightPlayerIcon.getIcon() == aiPlayerNormalIcon) {
                    if (rightPlayerIcon.getIcon() == aiPlayerEasyIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerEasy.class, GameController.semesterToBoardSize(semesterCounter));
                    } else if (rightPlayerIcon.getIcon() == aiPlayerNormalIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerMedium.class, GameController.semesterToBoardSize(semesterCounter));
                    } else if (rightPlayerIcon.getIcon() == aiPlayerHardIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerHard.class, GameController.semesterToBoardSize(semesterCounter));
                    }
                } else if (rightPlayerIcon.getIcon() == aiPlayerHardIcon) {
                    if (rightPlayerIcon.getIcon() == aiPlayerEasyIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerEasy.class, GameController.semesterToBoardSize(semesterCounter));
                    } else if (rightPlayerIcon.getIcon() == aiPlayerNormalIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerMedium.class, GameController.semesterToBoardSize(semesterCounter));
                    } else if (rightPlayerIcon.getIcon() == aiPlayerHardIcon) {
                        GameController.startLocalGame(HumanPlayer.class, leftPlayerNickname, SpecificAiPlayerHard.class, GameController.semesterToBoardSize(semesterCounter));
                    }
                }

            }
        });
         */
    }

    // TOGGLE METHODEN
    private void togglePlayerIconLeft() {
        if (PlayerIcon.getIcon() == humanPlayerIcon) {
            PlayerIcon.setIcon(aiPlayerHardIcon);
        } else if (PlayerIcon.getIcon() == aiPlayerEasyIcon){
            PlayerIcon.setIcon(humanPlayerIcon);
        } else if (PlayerIcon.getIcon() == aiPlayerNormalIcon) {
            PlayerIcon.setIcon(aiPlayerEasyIcon);
        } else if (PlayerIcon.getIcon() == aiPlayerHardIcon) {
            PlayerIcon.setIcon(aiPlayerNormalIcon);
        }
    }

    private void togglePlayerIconRight() {
        if (PlayerIcon.getIcon() == humanPlayerIcon) {
            PlayerIcon.setIcon(aiPlayerEasyIcon);
        } else if (PlayerIcon.getIcon() == aiPlayerEasyIcon){
            PlayerIcon.setIcon(aiPlayerNormalIcon);
        } else if (PlayerIcon.getIcon() == aiPlayerNormalIcon) {
            PlayerIcon.setIcon(aiPlayerHardIcon);
        } else if (PlayerIcon.getIcon() == aiPlayerHardIcon) {
            PlayerIcon.setIcon(humanPlayerIcon);
        }
    }

    private void updateTextFields() {
        if (PlayerIcon.getIcon() == humanPlayerIcon) {
            PlayerTextField.setText("Spieler 1");
        } else if (PlayerIcon.getIcon() == aiPlayerEasyIcon){
            PlayerTextField.setText("Einfach");
        } else if (PlayerIcon.getIcon() == aiPlayerNormalIcon) {
            PlayerTextField.setText("Mittel");
        } else if (PlayerIcon.getIcon() == aiPlayerHardIcon) {
            PlayerTextField.setText("Schwer");
        }
    }
}
